// Copyright 2024 Universidad Politecnica de Madrid (UPM)
// Authors: Santiago Tapia-Fernández
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

// --------------------------------------------------------------
//     ATTENTION:    DO NOT EDIT!!
// --------------------------------------------------------------
// This file has been automatically generated by Archetypes.
// Any manual changes will be overwritten the next time the file
// is regenerated.
//
// Archetype was `arty_basic_node' version 1.0.0
// Generation datetime: 2025-03-04 19:34:24.723844
// --------------------------------------------------------------

#include "std_msgs/msg/float64.hpp"
#include "std_srvs/srv/set_bool.hpp"

#include <chrono>
using namespace std::chrono_literals; // For timer periods

#include "arty_example_sinusoid_emitter/trigger_gen.hpp"
#include "rclcpp/rclcpp.hpp"

namespace arty_example_sinusoid_emitter
{
class node : public rclcpp::Node
{
public:
  node(const rclcpp::NodeOptions & options) : Node("arty_example_sinusoid_emitter", options)
  {
      // [ Parameters ]
  param_subscriber_ = std::make_shared<rclcpp::ParameterEventHandler>(this);

  ins.amplitude = this->declare_parameter<double>("amplitude", 3.0);
  amplitude_callback_handle_ = param_subscriber_->add_parameter_callback("amplitude",
    std::bind(&node::amplitude_param_callback, this, std::placeholders::_1)
  );
  ins.frequency = this->declare_parameter<double>("frequency", 2.0);
  frequency_callback_handle_ = param_subscriber_->add_parameter_callback("frequency",
    std::bind(&node::frequency_param_callback, this, std::placeholders::_1)
  );



    tick_timer = this->create_wall_timer(10ms, std::bind(&node::tick_callback, this));

    sub_offset = this->create_subscription<std_msgs::msg::Float64>(
      "offset", 10, std::bind(&node::callback_offset, this, std::placeholders::_1));

    pub_sin = this->create_publisher<std_msgs::msg::Float64>(
      "sin", 10);

    outs.init(				pub_sin);

    only_positive_server = this->create_service<std_srvs::srv::SetBool>(
      "only_positive", std::bind(&node::only_positive_srv_callback,
      this, std::placeholders::_1, std::placeholders::_2));

  }

private:
    // [Parameters]
  std::shared_ptr<rclcpp::ParameterEventHandler> param_subscriber_;
  std::shared_ptr<rclcpp::ParameterCallbackHandle> amplitude_callback_handle_;
  void amplitude_param_callback(const rclcpp::Parameter & param) {
    RCLCPP_DEBUG(get_logger(), "Updated param: %s", param.get_name().c_str());
    ins.amplitude = param.get_value<double>();  }
  std::shared_ptr<rclcpp::ParameterCallbackHandle> frequency_callback_handle_;
  void frequency_param_callback(const rclcpp::Parameter & param) {
    RCLCPP_DEBUG(get_logger(), "Updated param: %s", param.get_name().c_str());
    ins.frequency = param.get_value<double>();  }



  rclcpp::TimerBase::SharedPtr tick_timer;

  void tick_callback()
  {
    RCLCPP_DEBUG(this->get_logger(), "Running callback for tick");
    tick_triggered(ins, outs, recv);
    RCLCPP_DEBUG(this->get_logger(), "callback for tick completed");
  }

  rclcpp::Subscription<std_msgs::msg::Float64>::SharedPtr sub_offset;
  void callback_offset (const std_msgs::msg::Float64 & msg) {
    RCLCPP_DEBUG(this->get_logger(), "Running callback for offset");
    ins.offset = msg;
    RCLCPP_DEBUG(this->get_logger(), "callback for offset completed");
  }

  rclcpp::Publisher<std_msgs::msg::Float64>::SharedPtr pub_sin;

  // [SERVICES]
  rclcpp::Service<std_srvs::srv::SetBool>::SharedPtr only_positive_server;

  void only_positive_srv_callback(
      const std::shared_ptr<std_srvs::srv::SetBool::Request> request,
            std::shared_ptr<std_srvs::srv::SetBool::Response> response)
  {
    RCLCPP_DEBUG(get_logger(), "Running callback for only_positive");
    only_positive_triggered(ins, outs, recv, request, response);
    RCLCPP_DEBUG(get_logger(), "callback for only_positive completed");
  }

  // [ Attributes for storing all inputs, outputs and received responses ]
  arty_example_sinusoid_emitter::inputs ins;
  arty_example_sinusoid_emitter::outputs outs;
  arty_example_sinusoid_emitter::responses recv;

};

}  // namespace arty_example_sinusoid_emitter

#include <rclcpp_components/register_node_macro.hpp>
RCLCPP_COMPONENTS_REGISTER_NODE(arty_example_sinusoid_emitter::node)